package mvd.jester.model;

public class SubtaskContext {
    private long remainingExecutionTime;
    private final Subtask subtask;

    public SubtaskContext(final Subtask subtask) {
        this.remainingExecutionTime = subtask.getWcet();
        this.subtask = subtask;
    }

    /**
     * @return the job
     */
    public Subtask getSubtask() {
        return subtask;
    }


    /**
     * @return the wcet
     */
    public long getRemainingExecutionTime() {
        return remainingExecutionTime;
    }

    /**
     * @param wcet the wcet to set
     */
    public void setRemainingExecutionTime(final long wcet) {
        this.remainingExecutionTime = wcet;
    }

    public void updateRemainingExecutionTime(final long time) {
        this.remainingExecutionTime -= time;
    }

    @Override
    public String toString() {
        return getSubtask() + ":" + getRemainingExecutionTime();
    }

}
