package mvd.jester.simulator.events;

import mvd.jester.simulator.model.JobContext;

public class JobCompletedEvent extends AbstractEvent {

    private JobContext job;

    public JobCompletedEvent(long time, JobContext job) {
        super(EventType.JOB_COMPLETED, time);
        this.job = job;
    }

    /**
     * @return the job
     */
    public JobContext getJobContext() {
        return job;
    }

    @Override
    protected String getLoggingMessage() {
        return "Job " + job + " completed";
    }

}
