package mvd.jester.simulator.events;

import mvd.jester.simulator.model.ExtendedSubtaskContext;
import mvd.jester.simulator.model.ProcessorContext;

public class SubtaskCheckCompletedEvent extends AbstractContextEvent {

    private final ProcessorContext processor;

    public SubtaskCheckCompletedEvent(final long time, final ExtendedSubtaskContext subtask,
            final ProcessorContext processor) {
        super(EventType.SUBTASK_CHECK_COMPLETED, time, subtask, subtask.getJobContext());
        this.processor = processor;
    }

    /**
     * @return the processor
     */
    public ProcessorContext getProcessor() {
        return processor;
    }

    @Override
    protected String getLoggingMessage() {
        return "Subtask " + getSubtaskContext() + " maybe completed on " + getProcessor();
    }

}
