package mvd.jester.simulator.events;

import mvd.jester.simulator.model.ExtendedSubtaskContext;
import mvd.jester.simulator.model.ProcessorContext;

public class SubtaskStoppedEvent extends AbstractContextEvent {

    private ProcessorContext processor;

    public SubtaskStoppedEvent(long time, ExtendedSubtaskContext subtask,
            ProcessorContext processor) {
        super(EventType.SUBTASK_STOPPED, time, subtask, subtask.getJobContext());
        this.processor = processor;
    }

    /**
     * @return the processor
     */
    public ProcessorContext getProcessor() {
        return processor;
    }

    @Override
    protected String getLoggingMessage() {
        return "Subtask " + getSubtaskContext() + " stopped on " + getProcessor();
    }

}
