package mvd.jester.simulator.model;

import java.util.Optional;
import mvd.jester.model.Subtask;
import mvd.jester.model.SubtaskContext;

public class ExtendedSubtaskContext extends SubtaskContext {

    private final JobContext jobContext;
    private Optional<ThreadContext> executingThread;

    public ExtendedSubtaskContext(JobContext jobContext, Subtask subtask) {
        super(subtask);
        this.jobContext = jobContext;
        this.executingThread = Optional.empty();
    }

    public JobContext getJobContext() {
        return jobContext;
    }

    public void assignThread(ThreadContext threadContext) {
        this.executingThread = Optional.of(threadContext);
    }

    public boolean hasThread() {
        return executingThread.isPresent();
    }

    public Optional<ThreadContext> getThread() {
        return executingThread;
    }

    @Override
    public String toString() {
        return getSubtask() + " of task " + getJobContext().getTask();
    }
}
