package mvd.jester.simulator.model;

import java.util.Optional;

public class ThreadContext {

    private final long threadId;
    private final JobContext jobContext;
    private Optional<ExtendedSubtaskContext> subtask;

    public ThreadContext(long threadId, JobContext jobContext) {
        this.threadId = threadId;
        this.jobContext = jobContext;
        this.subtask = Optional.empty();
    }

    /**
     * @return the jobContext
     */
    public JobContext getJobContext() {
        return jobContext;
    }

    public void assignSubtask(ExtendedSubtaskContext subtask) {
        this.subtask = Optional.ofNullable(subtask);
    }

    public Optional<ExtendedSubtaskContext> getSubtask() {
        return subtask;
    }

    @Override
    public String toString() {
        return "Thread " + threadId + " of " + jobContext;
    }

}
